function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import { exec } from 'child_process';
import { readdirSync, statSync } from 'fs';
import { join } from 'path';

var pExec = function pExec(command) {
  return new Promise(function (resolve, reject) {
    // eslint-disable-next-line max-params
    exec(command, function (error, stdout, stderr) {
      if (stderr) {
        console.error("stderr: ".concat(stderr));
      }

      if (error) {
        reject(error);
      }

      resolve(stdout);
    });
  });
};

var getAllFiles = function getAllFiles(dirPath) {
  var arrayOfFilesInput = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var files = readdirSync(dirPath);
  var arrayOfFiles = arrayOfFilesInput;
  files.forEach(function (file) {
    if (statSync(dirPath + '/' + file).isDirectory()) {
      arrayOfFiles = getAllFiles(dirPath + '/' + file, arrayOfFiles);
    } else {
      arrayOfFiles.push(join(dirPath, '/', file));
    }
  });
  return arrayOfFiles;
};

var TMP_FOLDER = '/tmp/serverless-esbuild-bundle-analyzer';

function bundleVisualizer() {
  return _bundleVisualizer.apply(this, arguments);
}

function _bundleVisualizer() {
  _bundleVisualizer = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var functionName, functionZipName, TEMP_DIR_LOCATION, test, metafileName;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            functionName = this.options.analyze;

            if (!(functionName === undefined)) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return");

          case 3:
            functionZipName = this.serverless.service.getAllFunctionsNames().find(function (fullFunctionName) {
              return fullFunctionName.endsWith(functionName);
            });

            if (!(functionZipName === undefined)) {
              _context.next = 7;
              break;
            }

            this.serverless.cli.log("\uD83E\uDD2F Analyze failed: function ".concat(functionName, " was not found"), 'ServerlessAnalyzeBundlePlugin', {
              color: 'red'
            });
            return _context.abrupt("return");

          case 7:
            this.serverless.cli.log("\u23F3 Analyzing function ".concat(functionName), 'ServerlessAnalyzeBundlePlugin');
            TEMP_DIR_LOCATION = "".concat(TMP_FOLDER, "/").concat(functionZipName, "/").concat(new Date().getTime());
            _context.next = 11;
            return pExec("mkdir -p ".concat(TEMP_DIR_LOCATION));

          case 11:
            _context.next = 13;
            return pExec("unzip .serverless/".concat(functionZipName, " -d ").concat(TEMP_DIR_LOCATION));

          case 13:
            test = getAllFiles("".concat(TEMP_DIR_LOCATION));
            metafileName = test.filter(function (fileName) {
              return fileName.includes("/".concat(functionName, "/")) && fileName.endsWith('-meta.json');
            })[0];
            _context.next = 17;
            return pExec(['node_modules/.bin/esbuild-visualizer', '--metadata', metafileName, '--filename', "".concat(TEMP_DIR_LOCATION, "/").concat(functionName, ".html"), '--open'].join(' '));

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _bundleVisualizer.apply(this, arguments);
}

export default bundleVisualizer;
//# sourceMappingURL=bundleVisualizer.js.map