function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import bundleVisualizer from './bundleVisualizer';
export var ServerlessAnalyzeBundlePlugin = function ServerlessAnalyzeBundlePlugin(serverless, options) {
  var _this = this;

  _classCallCheck(this, ServerlessAnalyzeBundlePlugin);

  this.bundleVisualizer = bundleVisualizer.bind(this);
  this.options = options;
  this.serverless = serverless;
  this.commands = {
    "package": {
      usage: 'Analyze the bundle of a lambda function',
      options: {
        analyze: {
          // @ts-expect-error plugin is badly typed 🤔
          type: 'string',
          usage: 'Specify the function you want to analyze (e.g. "--analyze \'helloWorld\'")'
        }
      }
    }
  };
  this.hooks = {
    'before:package:initialize': function beforePackageInitialize() {
      var analyze = _this.options.analyze;

      if (analyze === undefined) {
        return;
      } // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access


      _this.serverless.service.custom.esbuild.metafile = true;
    },
    'after:package:finalize': function () {
      var _afterPackageFinalize = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var analyze;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                analyze = _this.options.analyze;

                if (!(analyze === undefined)) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                _context.next = 5;
                return _this.bundleVisualizer();

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function afterPackageFinalize() {
        return _afterPackageFinalize.apply(this, arguments);
      }

      return afterPackageFinalize;
    }()
  };
};
//# sourceMappingURL=serverlessAnalyzeBundle.js.map